> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Preference

> Gets a specific user preference value.

`Unary` · [`Users`](/docs/api-reference/generated/user/overview)

Gets a specific user preference value.

Use this method to:

* Retrieve user settings
* Read preference values
* Check configurations

### Examples

* Get preference:

  Retrieves a specific preference value.

  ```yaml theme={null}
  preferenceId: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.UserService/GetPreference
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.UserService/GetPreference" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "userPreferenceId": "<user-preference-id>"
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.user_pb2 as user_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = user_pb2.GetPreferenceRequest(
      user_preference_id="<user-preference-id>",
  )
  response = ona.services.user.get_preference(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { GetPreferenceRequestSchema } from "@gitpod/sdk/gitpod/v1/user_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(GetPreferenceRequestSchema, {
      userPreferenceId: "<user-preference-id>",
    });
    const response = await ona.services.user.getPreference(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.GetPreferenceRequest{
  		UserPreferenceId: "<user-preference-id>",
  	})
  	response, err := ona.Services.User.GetPreference(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "userPreferenceId": "<user-preference-id>"
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.GetPreferenceRequest`

| Field              | Type   | Required | Description                                          |
| ------------------ | ------ | -------- | ---------------------------------------------------- |
| `userPreferenceId` | string | No       | **Deprecated.**                                      |
| `preferenceId`     | string | No       |                                                      |
| `preferenceKey`    | string | No       | Constraints: `string.max_len=255, string.min_len=1`. |

## Response

`gitpod.v1.GetPreferenceResponse`

| Field        | Type                                              | Required | Description |
| ------------ | ------------------------------------------------- | -------- | ----------- |
| `preference` | [UserPreference](#type-gitpod-v1-user-preference) | No       |             |

## Related types

<a id="type-gitpod-v1-user-preference" />

<Accordion title="UserPreference">
  `gitpod.v1.UserPreference`

  | Field       | Type               | Required | Description                                                                                                                                                                   |
  | ----------- | ------------------ | -------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
  | `key`       | string             | No       | Constraints: `string.max_len=255, string.min_len=1`.                                                                                                                          |
  | `value`     | string             | No       | omitting value field will cause an error due to min\_len validation, to unset a preference use DeletePreference instead Constraints: `string.max_len=2480, string.min_len=1`. |
  | `id`        | string             | No       | Constraints: `string.uuid=true`.                                                                                                                                              |
  | `createdAt` | RFC 3339 timestamp | No       |                                                                                                                                                                               |
  | `updatedAt` | RFC 3339 timestamp | No       |                                                                                                                                                                               |
</Accordion>
